extern inline void OutputText(u8 screen, u8 x, u8 y, char *text, u8 limit)
{
	char temp = text[limit];
	text[limit] = 0;
	PA_OutputText(screen, x, y, text);
	text[limit] = temp;
}


void manipulation_fichier(u32 fichier_choix)
{
   //traitement pour lire le fichier
	Player_Stop();
	LectureEnCours = 0;
				
	//On rallume la frequence de tous les canaux
	u8 c;
	for (c = 0; c < 32; c++)
	{
	   canal [c] = 1;
	   PA_SetSpriteAnim(1, 32 + c, 0);
	}
   
   Lecture = 1;
   
   //Manipulation fichier
	char debut[80]="//Musics//";
	char *fin;
	strcpy(debut, "//Musics//");
	fin = files[fichier_choix].filename;
	strcat(debut, fin);

	FILE* binFile = fopen(debut, "rb");
	u32 binSize;
	fseek (binFile, 0 , SEEK_END);
	binSize = ftell (binFile);
	rewind (binFile);
	fclose (binFile);

	PA_OutputText(1, 12, 18, "loading...");

	Player_Free(module);
	chargement = 1;
	module = Player_Load(debut,binSize,64);

	PA_OutputText(1, 8, POS_TITRE, "                       ");
	OutputText(1, 8, POS_TITRE, strupr(files[fichier_choix].filename), 23);
	PA_OutputText(1, 7, POS_TAILLE, "%d           ", binSize);
	PA_OutputText(1, 11, POS_CANAUX, "%02d/", module->numchn);
	PA_OutputText(1, 1, POS_TRACKER + 1, "                              ");
	OutputText(1, 1, POS_TRACKER + 1, strupr(module->modtype), 30);

	TIMER0_CR = 0;
	irqSet(IRQ_TIMER0, TimerInterrupt);
	irqEnable(IRQ_TIMER0);
	TIMER0_DATA = TIMER_FREQ_256(md_bpm * 50 / 125);
	TIMER0_CR = TIMER_DIV_256 | TIMER_IRQ_REQ | TIMER_ENABLE;
				
	Player_Start(module);
	Player_SetVolume(volume);
	chargement = 0;
	PA_VBLCounterStart(0);
	LectureEnCours = 1;
	PA_OutputText(1, 12, 18, "          ");
}


void temporisation(u16 temps)
{
	u16 z = 0;
	while (z < temps)
	{
		z++;
		PA_WaitForVBL();
	}
}


void attente_ou_touche(u16 temps)
{
	u16 z = 0;
	while (z < temps)
	{
		z++;
		//test stylus ou pad
		if(Stylus.Newpress || Pad.Newpress.A) {z = temps;}
		PA_WaitForVBL();
	}
	Stylus.Newpress = false;
	Pad.Newpress.A = false;
}


void pause()
{
	Stylus.Newpress = false;
	Pad.Newpress.Select = false;
	u8 z=0;
	while(z==0)
	{
		PA_WaitForVBL();
		if (Stylus.Newpress || Pad.Newpress.Anykey) {z=1;}
	}
	Stylus.Newpress = false;
	Pad.Newpress.Anykey = false;
}


void nettoyer_tiles_bg2_bas()
{
	u8 atx = 0;
	u8 aty = 0;
	for (atx=0;atx<32;atx++)
	{
		for (aty=0;aty<24;aty++)
		{
			PA_SetMapTileEx(0,2,atx,aty,damier8x8_256x256_Map[0],0,0,0);
		}
	}
}


void ligne_selection(u8 ety)
{
	nettoyer_tiles_bg2_bas();

	u8 etx = 0;
	for (etx = 0;etx < 32; etx++)
	{
		PA_SetMapTileEx(0,2,etx,ety,damier8x8_256x256_Map[1],0,0,0);
	}
}


void effacer_texte_bas()
{
	u8 i = 0;
	for (i=0;i<22;i++)
	{
		PA_OutputSimpleText(0, 0, i, "                                ");
	}
}


void affichage_liste_fichier()
{
	fichier_debut = page_courante * 18;
	fichier_fin = (page_courante + 1) * 18;
	if (fichier_fin > FileNumber)
	{
		fichier_fin = FileNumber;
	}
	effacer_texte_bas();
	s32 i;
	macolonne = 3;
	for (i = fichier_debut; i < fichier_fin; i++)
	{
		OutputText(0, 1, macolonne, strupr(files[i].filename), 30);
		macolonne++;
	}
}


void voir_fleche_gauche()
{
	PA_SetSpriteAnim(0, 0, 1);
}


void voir_fleche_droite()
{
	PA_SetSpriteAnim(0, 1, 1);
}


void animation_fleche_gauche()
{
	if (page_courante == page_courante_sel)
	{
		ligne_selection(ligne_courante_sel+3);
	}
	else
	{
		ligne_selection(0);
	}

	PA_SetSpriteAnim(0, 0, 2);
	affichage_liste_fichier();
	PA_OutputText(0, 10, 22, "page %02d / %02d ", page_courante + 1, page_fin + 1);
	temporisation(15);
	PA_SetSpriteAnim(0, 0, 1);
}


void animation_fleche_droite()
{
	if (page_courante == page_courante_sel)
	{
		ligne_selection(ligne_courante_sel+3);
	}
	else
	{
		ligne_selection(0);
	}

	PA_SetSpriteAnim(0, 1, 2);
	affichage_liste_fichier();
	PA_OutputText(0, 10, 22, "page %02d / %02d ", page_courante + 1, page_fin + 1);
	temporisation(15);
	PA_SetSpriteAnim(0, 1, 1);
}

void vumetrevide()
{
	u8 colonnes = 0;
	u8 lignes = 0;

	for (colonnes = 0; colonnes < 32; colonnes++)
	{
		for (lignes = 12; lignes < 24; lignes++)
		{
			PA_SetMapTileEx(1,2,colonnes,lignes,BG1_2_Map[1],0,0,0);	
		}
	}
}


void aff_vumetre(u8 colonnes, u8 canal)
{
   u32 valeur;
   
   if (Voice_Stopped(colonnes) == 0)
   {
		valeur = (Voice_GetFrequency(colonnes)*canal);
	}
	else
	{
	   valeur = 0;
	} 
	
	 		
	u32 TRANCHE = (MAX-MIN);
	u8 i = 0;
	u8 lignes = 23;//la plus en bas et on remonte

	//echelle actuelle (MIN  MAX)
	if (valeur < MIN) {valeur = MIN;}
	else if (valeur > MAX) {valeur = MAX;}
	
	//commencer  zro la tranche
	valeur -= MIN;

	//changement d'chelle (0 a 48) pour la gestion en TILES
	u8 new_valeur = ceil (  (valeur*48)  / TRANCHE);
	//u8 new_valeur = colonnes;

	//notre vumtre en 12 morceaux
	u8 MesTiles[12] = {4,4,4,4,4,4,4,4,4,4,4,4};

	u8 Morceaux_plein = new_valeur / 4;
	u8 Morceaux_reste = new_valeur - (Morceaux_plein * 4);

	for (i = 1; i <= (12 - Morceaux_plein); i++)
	{
	//effacer ceux qui ne sont pas plein en partant du haut
		MesTiles[12-i] = 0;
	}

	if (Morceaux_reste != 0)
	{
	   //y'en a un qui n'est pas vide et qui n'est pas plein (ni 0, ni 4)
		MesTiles[Morceaux_plein] = Morceaux_reste;
	}

	//le sprite
	vumetreCol[colonnes].nouveau = new_valeur;
	if (vumetreCol[colonnes].ancien <= vumetreCol[colonnes].nouveau)
	{
		vumetreCol[colonnes].ancien = vumetreCol[colonnes].nouveau;
		PA_SetSpriteY(1, colonnes, POSBAS - (vumetreCol[colonnes].ancien * 2) - 1);
	}
	else
	{
		vumetreCol[colonnes].ancien--;
		PA_SetSpriteY(1, colonnes, POSBAS - (vumetreCol[colonnes].ancien * 2) - 1);
	}

	//afficher
	//vert fonc - 3 de haut
	PA_SetMapTileEx(1,1,colonnes,lignes,BG1_1_Map[0 + (MesTiles[0]*32)],0,0,0);
	PA_SetMapTileEx(1,1,colonnes,lignes-1,BG1_1_Map[0 + (MesTiles[1]*32)],0,0,0);
	PA_SetMapTileEx(1,1,colonnes,lignes-2,BG1_1_Map[0 + (MesTiles[2]*32)],0,0,0);
	//vert  clair - 2 de haut
	PA_SetMapTileEx(1,1,colonnes,lignes-3,BG1_1_Map[1 + (MesTiles[3]*32)],0,0,0);
	PA_SetMapTileEx(1,1,colonnes,lignes-4,BG1_1_Map[1 + (MesTiles[4]*32)],0,0,0);
	//jaune - 1 de haut
	PA_SetMapTileEx(1,1,colonnes,lignes-5,BG1_1_Map[2 + (MesTiles[5]*32)],0,0,0);
	//orange pale - 2 de haut
	PA_SetMapTileEx(1,1,colonnes,lignes-6,BG1_1_Map[3 + (MesTiles[6]*32)],0,0,0);
	PA_SetMapTileEx(1,1,colonnes,lignes-7,BG1_1_Map[3 + (MesTiles[7]*32)],0,0,0);
	//orange fonc - 2 de haut
	PA_SetMapTileEx(1,1,colonnes,lignes-8,BG1_1_Map[4 + (MesTiles[8]*32)],0,0,0);
	PA_SetMapTileEx(1,1,colonnes,lignes-9,BG1_1_Map[4 + (MesTiles[9]*32)],0,0,0);
	//rouge - 2 de haut
	PA_SetMapTileEx(1,1,colonnes,lignes-10,BG1_1_Map[5 + (MesTiles[10]*32)],0,0,0);
	PA_SetMapTileEx(1,1,colonnes,lignes-11,BG1_1_Map[5 + (MesTiles[11]*32)],0,0,0);
}
