#include <PA9.h>
#include <math.h>

#include <fat.h>
#include <sys/dir.h>
#include <stdio.h>

#include <mikmod9.h>

#include "gfx/all_gfx.c"
#include "gfx/all_gfx.h"

typedef struct{
	u8 ancien;
	u8 nouveau;
} channeltype;
channeltype vumetreCol[32];
#define POSBAS 192

#include "sprites.h"

#define POS_TIME 7
#define POS_TITRE 3
#define POS_TAILLE 5
#define POS_CANAUX 7
#define POS_TRACKER 9

u8 navigateur = 0;//0 = off ; 1 = on
u16 page_fin = 0;
s16 page_courante = 0;
s16 page_courante_sel = 0;
s16 ligne_courante_sel = 0;
u8 position_choix = 0;
u16 fichier_choix = 0;
u16 fichier_debut = 0;
u16 fichier_fin = 0;
u8 macolonne = 0;
u32 FileNumber = 0;
u8 volume = 128;
u8 zz = 0;
u8 zzz = 0;

u32 MIN = 11000;
u32 MAX = 99000;

BOOL Muted = 0;
BOOL Switched = 0;
BOOL Normal = 1;
BOOL Repeat = 0;
BOOL Random = 0;

#define MAX_FILENAME_LEN 100;
char * buffer;
MODULE * module = NULL;
u8 chargement;
u8 LectureEnCours = 0;
u8 Lecture = 0;
u32 z = 500;

typedef struct{
   char filename[100];
   char name[100];
   char ext[10];
   u32 size;
}  PAfiletype;
PAfiletype files[1782];

char *ext [] = {
   "AMF", //OK
   "APUN",
   "DSM", //OK
   "FAR", //OK
   "GDM", //OK
   "IMF", //OK
   "IT", //OK
   "MED", //OK
   "MOD", //OK
   "MTM", //OK
   "OKT", //OK
   "S3M", //OK
   "STM", //OK
   "STX",
   "ULT", //OK
   "UNI", //BUG
   "XM" //OK
};

BOOL canal [32] = {
   1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,
	1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1
};	


/* MikMod */
void MikMod9_SendCommand(u32 command)
{
	while (REG_IPC_FIFO_CR & IPC_FIFO_SEND_FULL);
	REG_IPC_FIFO_TX = command;
}

void TimerInterrupt()
{
	MikMod_Update();

	TIMER0_DATA = TIMER_FREQ_256(md_bpm * 50 / 125);
}

extern inline char PA_GetSmall(char letter)
{
	if((letter >= 'A')&&(letter <= 'Z')) return (letter-'A'+'a');
	return letter;
}

s16 PA_FATSearchExt(DIR_ITER* dir, PAfiletype *filelist)
{
   s16 number = 0;
   u8 i, j, k;
   struct stat st;
      
   while (dirnext(dir, filelist[number].filename, &st) == 0) {
      if(!(st.st_mode & S_IFDIR)){

         i = 0;
         while( filelist[number].filename[i]) i++;
         while( filelist[number].filename[i-1] != '.') i--;
         
         u8 same = 0;
         for(k = 0; (k < 18) && !same; k++){
				same = 1;
				for(j = 0; ext[k][j]; j++){
					if(PA_GetSmall(ext[k][j]) !=  PA_GetSmall(filelist[number].filename[i+j])){
						same = 0; // not right extension
					}
				}
			}						
	 
         if(same){
				k--;
         
            for(j = 0; j < i-1; j++) filelist[number].name[j] = filelist[number].filename[j];
            filelist[number].name[j] = 0;
            
            for(i = 0; ext[i]; i++) filelist[number].ext[i] = ext[k][i];
            filelist[number].ext[i] = 0;
            
            filelist[number].size = st.st_size;
            
            number++;
          }      
      }   
   }   
   return number;
}

#include "fonctions.h"




int main (void)
{
	//*** INITIALISATION ***
	PA_Init();
	PA_InitVBL();

	PA_InitSound();
	PA_InitRand();
	
	//*** FAT ***
	fatInitDefault();	
	
	//*** MIKMOD ***
	MikMod_RegisterDriver(&drv_nds_sw);
	MikMod_RegisterAllLoaders();
	
	if (MikMod_Init("")) {PA_OutputText(0, 1, 2, "Could not initialize mikmod, reason:\n%s\n", MikMod_strerror(MikMod_errno)); return 1;}

	//*** SPLASH COMPO ***
	//PA_EasyBgLoad(1, 3, splash1);
	//PA_EasyBgLoad(0, 3, splash0);

	//attente_ou_touche(300);//5s
	
	PA_SplashBlue();

	PA_ResetBg(1);
	PA_ResetBg(0);
	
	PA_InitCustomText(1, 0, ecran_font); //ecran, background, font name => Chargement d'une font particulire
	PA_InitCustomText(0, 0, ecran_font);
	
	PA_OutputText(1, 6, 1, "FAT Player MikMod v5");
	PA_OutputText(1, 4, 3, "Cid2mizard and Kukulcan");
	PA_OutputText(1, 5, 4, "Thanks Mollusk, Redbug");
	PA_OutputText(1, 6, 5, "Thanks for the Palib");
	PA_OutputText(1, 4, 6, "Thanks for MikMod DS Lib");	
	PA_OutputText(1, 6, 8, "Press Screen to Play");
	PA_OutputText(1, 8, 9, "Press A to Stop");
	PA_OutputText(1, 8, 10, "Press B to Mute");
	PA_OutputText(1, 3, 11, "Press Up or Down to change");
	PA_OutputText(1, 12, 12, "Volume ");
	PA_OutputText(1, 5, 13, "Press R or L to change");
	PA_OutputText(1, 8, 14, "Zoom Frequencer");
	PA_OutputText(1, 2, 15, "Press Start to Switch screen");
	PA_OutputText(1, 2, 16, "Press Screen to Stop channel");
	PA_OutputText(1, 2, 17, "Press Select to Change mode.");
	PA_OutputText(1, 5, 18, "Normal, Repeat, Random");
	PA_OutputText(1, 6, 19, "Thanks to use this");
	PA_OutputText(1, 11, 20, "HOMEBREW");
	PA_OutputText(1, 4, 21, "Dedication to my daughter");
	PA_OutputText(1, 12, 22, "CAMMY.");
	
	PA_OutputText(0, 7, 1, "Format Supported");
	PA_OutputText(0, 1, 3, "669 (Composer 669, Unis 669)");
	PA_OutputText(0, 1, 4, "AMF (DSMI Advanced Module F...)");
	PA_OutputText(0, 1, 5, "AMF (ASYLUM Music Format V1...)");
	PA_OutputText(0, 1, 6, "APUN (APlayer)");
	PA_OutputText(0, 1, 7, "DSM (DSIK internal format)");
	PA_OutputText(0, 1, 8, "FAR (Farandole Composer)");
	PA_OutputText(0, 1, 9, "GDM (General DigiMusic)");
	PA_OutputText(0, 1, 10, "IT (Impulse Tracker)");
	PA_OutputText(0, 1, 11, "IMF (Imago Orpheus)");
	PA_OutputText(0, 1, 12, "MOD (15 and 31 instruments)");
	PA_OutputText(0, 1, 13, "MED (OctaMED)");
	PA_OutputText(0, 1, 14, "MTM (MultiTracker Module e...)");
	PA_OutputText(0, 1, 15, "OKT (Amiga Oktalyzer)");
	PA_OutputText(0, 1, 16, "S3M (Scream Tracker 3)");
	PA_OutputText(0, 1, 17, "STM (Scream Tracker)");
	PA_OutputText(0, 1, 18, "STX (Scream Tracker Music ...)");
	PA_OutputText(0, 1, 19, "ULT (UltraTracker)");
	PA_OutputText(0, 1, 20, "UNI (MikMod)");
	PA_OutputText(0, 1, 21, "XM (FastTracker 2)");
	
	attente_ou_touche(600); //10s
	
	PA_ResetBg(1);
	PA_ResetBg(0);
	
	PA_InitAllSpriteDraw();
	creation_des_sprites();
	

	//*** ECRANS ***//
	
	/////////////////
	//Ecran du Haut//
	/////////////////
	
	//BG 3
	PA_EasyBgLoad(1, 3, BG1_3);

	//BG 2
	PA_LoadSimpleBg(1,2,BG1_2_Tiles,Blank,BG_256X256,0,1);
	PA_LoadBgPal(1, 2, (void*)BG1_2_Pal);//ecran, bg, fond

	//BG 1	
	PA_LoadSimpleBg(1,1,BG1_1_Tiles,Blank,BG_256X256,0,1);
	PA_LoadBgPal(1, 1, (void*)BG1_1_Pal);//ecran, bg, fond
	
	//BG 0
	PA_InitText(1, 0);
	PA_InitCustomText(1, 0, ecran_font); //ecran, background, font name => Chargement d'une font particulire

	
	////////////////
	//Ecran du Bas//
	////////////////
	
	//BG 3
	PA_EasyBgLoad(0, 3, BG0_3);
	
	//BG 2
	PA_LoadSimpleBg(0,2,damier8x8_256x256_Tiles,Blank,BG_256X256,0,1);
	PA_LoadBgPal(0, 2, (void*)damier8x8_256x256_Pal);//ecran, bg, fond
	
	//BG 1
	PA_EasyBgLoad(0, 1, BG0_1);
	
	//BG 0
	PA_InitText(0, 0);
	PA_InitCustomText(0, 0, ecran_font); //ecran, background, font name => Chargement d'une font particulire

	DIR_ITER* dir;
	dir = diropen ("/Musics/");
	FileNumber = PA_FATSearchExt(dir, files);//attention il compte aussi les fichiers qui n'ont pas la bonne extension

	//18 fichiers par page, maximum 99 pages (donc 99 * 18 = 1782 fichiers de possibles)
	page_courante = 0;
	affichage_liste_fichier();

	//navigateur bas, si > 18 fichiers ?
	//crer le module de navigation en bas d'cran ?
	navigateur = 0;
	if (FileNumber > 18)
	{
		//on a plus d'une page
		navigateur = 1;
	}

	if (navigateur == 1)
	{
		page_fin = FileNumber/18;

		//fleche
		voir_fleche_gauche();
		voir_fleche_droite();

		//afficher nombre de page
		//page_courante + 1 / page_fin
		PA_OutputText(0, 10, 22, "page %02d / %02d ", page_courante + 1, page_fin + 1);
	}
	
	PA_OutputText(1, 18, 1, "MikMod v%d.%d.%d",LIBMIKMOD_VERSION_MAJOR,LIBMIKMOD_VERSION_MINOR,LIBMIKMOD_REVISION);
	PA_OutputText(1, 1, 1, "%d Files",FileNumber);
	PA_OutputText(1, 1, POS_TITRE, "Title:");
	PA_OutputText(1, 1, POS_TAILLE, "Size:");
	PA_OutputText(1, 1, POS_CANAUX, "Channels:");
	PA_OutputText(1, 17, POS_TIME, "Time:");
	PA_OutputText(1, 12, POS_TRACKER, "Tracker:");

	Player_SetVolume(0);
	
	vumetrevide();

	for (zzz=0;zzz<32;zzz++)
	{
		PA_SetSpriteY(1, zzz, POSBAS - (vumetreCol[zzz].ancien * 2) - 1);
	}

	zz = 0;
	while (1)
	{
		if (zz == 2 || zz == 4 || zz == 6)
		{
			for (zzz = 0; zzz < 32; zzz++)
			{
				if (vumetreCol[zzz].ancien <= vumetreCol[zzz].nouveau)
				{
					//que dalle
				}
				else
				{
					vumetreCol[zzz].ancien--;
					PA_SetSpriteY(1, zzz, POSBAS - (vumetreCol[zzz].ancien * 2) -1);
				}
			}
		}

		if (zz == 6)
		{
			for (zzz = 0; zzz < 32; zzz++)
			{
			   aff_vumetre(zzz, canal [zzz]);  
			}
			zz = 0;
		}
		else
		{
			zz++;
			if (zz > 31) {zz = 0;}
		}


		//dans la zone des fichiers uniquement ?
		if (Stylus.Newpress && PA_StylusInZone(0,24,255,167) && chargement==0 && Switched == 0)
		{
			position_choix = (Stylus.Y - 24) / 8;//connaitre le numro de la ligne touch
			//savoir si un fichier est prsent a cette position
			fichier_choix = (page_courante * 18) + position_choix;
			if (fichier_choix < fichier_fin)
			{
				//info pour le changement de page et retrouver la bonne slection
				page_courante_sel = page_courante;
				ligne_courante_sel = position_choix;

				//alors on click sur une zone qui a un fichier
				ligne_selection(position_choix+3);   
				
				manipulation_fichier(fichier_choix);
			}

			Stylus.Newpress = false;
		}

		if ( Stylus.Newpress && navigateur == 1 && PA_SpriteTouched(0) )
		{
			if (page_courante > 0)
			{
				page_courante--;
				animation_fleche_gauche();
			}
			else
			{
				//pas bon, une action ?
			}
			Stylus.Newpress = false;
		}

		if ( Stylus.Newpress && navigateur == 1 && PA_SpriteTouched(1) )
		{
			if (page_courante < page_fin )
			{
				page_courante++;
				animation_fleche_droite();
			}
			else
			{
				//pas bon, une action ?
			}
			Stylus.Newpress = false;
		}
		
		if ( !Player_Active())
		{
		   LectureEnCours = 0;
		   
		   u8 e;
			for (e = 0; e < 32; e++)
			{
			   canal [e] = 0;
			   PA_SetSpriteAnim(1, 32 + e, 0);
			}
			
			if (Repeat == 1 && Lecture == 1)
			{			   
			   manipulation_fichier(fichier_choix);
			}
			
			if (Random == 1)
			{
			   fichier_choix = (PA_Rand()%FileNumber);
			   
			   manipulation_fichier(fichier_choix);
			}						
		}   
		
		if ( LectureEnCours != 0 )
		{
			PA_OutputText(1, 14, POS_CANAUX, "%02d", module->realchn);
			PA_OutputText(1, 23, POS_TIME, "%d:%02d:%02d",module->sngtime/60000,module->sngtime/1000%60,module->sngtime/10%100);
		}
		else
		{
			Player_Stop();
		}							  

		//Stop la lecture avec A
		if ( Pad.Newpress.A )
		{
			LectureEnCours = 0;
			Player_Stop();
			u8 s;
			for (s = 0; s < 32; s++)
			{
			   PA_SetSpriteAnim(1, 32 + s, 0);
			}
		}
		
		//Mute avec le bouton B
		if ( Pad.Newpress.B && Muted == 0 )
		{
			Player_SetVolume(0);
			Muted = 1;
		}
		else if ( Pad.Newpress.B && Muted != 0 )
		{
		   Player_SetVolume(volume);
			Muted = 0;
		}
		
		//On change l'echelle du vusualiseur
		if ( Pad.Newpress.R ) MAX += 11000;
		else if (Pad.Newpress.L ) MAX -= 11000;
		
		if ( MAX <= 22000 ) MAX = 22000;
		else if ( MAX >= 99000 ) MAX = 99000;
		
		//Le VOLUME
		if ( Pad.Held.Up && volume < 128 ) {volume++; Player_SetVolume(volume);}
		else if ( Pad.Held.Down && volume > 0 ) {volume--; Player_SetVolume(volume);}
		
		//Switch ecran
		if ( Pad.Newpress.Start && Switched == 0 )
		{
		   PA_SwitchScreens();
		   Switched  = 1;
		}
		else if ( Pad.Newpress.Start && Switched != 0 )
		{
		   PA_SwitchScreens();
		   Switched  = 0;
		}
		
		//Normal,Repeat,Random
		if (Pad.Newpress.Select && Normal == 1)
		{
		   Normal = 0;
		   Repeat = 1;
		}
		else if (Pad.Newpress.Select && Repeat == 1)
		{
		   Repeat = 0;
			Random = 1;
		}
		else if (Pad.Newpress.Select && Random == 1)
		{
		   Random = 0;
			Normal = 1;
		}							   
		
		//Manipulation des canaux
		if ( Stylus.Newpress && Switched != 0 && canal [Stylus.X/8] != 0 && Stylus.Y > 96)
		{
		   Player_Mute(Stylus.X/8);
		   canal [Stylus.X/8] = 0;
		   PA_SetSpriteAnim(1, 32 + (Stylus.X/8), 1);
		}
		else if ( Stylus.Newpress && Switched != 0 && canal [Stylus.X/8] == 0 && Stylus.Y > 96)
		{
		   Player_Unmute(Stylus.X/8);
		   canal [Stylus.X/8] = 1;
		   PA_SetSpriteAnim(1, 32 + (Stylus.X/8), 0);
		}
					  
		//INFOS
		PA_OutputText(1, 2, 8, "Normal:%d  Repeat:%d  Random:%d",Normal,Repeat,Random);
		PA_OutputText(1, 10, 11, "MAXI: %04d",MAX);
		PA_OutputText(1, 22, POS_TAILLE, "Vol: %03d ",volume);
		
		PA_CheckLid();

		PA_WaitForVBL();
	}
	return 0;
}
